/* jshint esversion: 6 */

const fs = require('fs-extra');
const path = require('path');

module.exports.utils = {
    isLogged: true,
    appinfo: {},
    output_folder: "",
    log: function (txt, underlineCharacter) {
        if (this.isLogged) {
            console.log(txt);
            if (underlineCharacter === true) underlineCharacter = '-';
            if (this.isLogged && underlineCharacter) console.log(txt.replace(/[\t\r\n]/g, '').replace(/./g, underlineCharacter));
        }
    },
    outputFile: function (name, ext, content, tidy = false) {
        if (tidy) {
            content = content.replace(/\n([\t ]+\n)+/g, "\n\n"); // remove (multiple) whitespace-only lines, leaving 1 blank line
            content = content.replace(/\n\n+/g, "\n\n"); // collapse multiple \n to 2 at most
            content = content.replace(/\n+$/, "\n"); // finish file with 1 blank line at most
        }
        var filename = path.join(this.output_folder, `${name}.${ext}`);
        fs.outputFileSync(filename, content);
        this.log(`outputFile: ${filename} [${content.length} bytes]`);
        return null;
    },
    header: function (config, lang) {
        let [sep, start, inter, end] = ({
            common: ['\n', '/*', '  ', '*/'],
            js: ['\n', '/*', ' *', ' */'],
            sql: ['', '--', '', '']
        })[lang || 'common'];
        return `${start}${sep}${inter} Generated by ${this.appinfo.name} v${this.appinfo.version}${sep}${inter}${sep}${inter} DO NOT EDIT BY HAND!${sep}${end}`;
    }
};
